<script setup lang="ts">
import { v4 as uuidv4 } from 'uuid'

interface BaseCheckBoxProps {
  modelValue?: boolean
  label: string
}

const {
  modelValue = false,
  label,
} = defineProps<BaseCheckBoxProps>()
const emit = defineEmits(['update:modelValue'])
const id = uuidv4()
</script>

<template>
  <label class="flex flex-row gap-2 items-center">
    <div class="p-[3px] bg-gray-200 w-16 h-8 rounded-[1rem] relative border dark:border-none dark:p-1">
      <input
        :id="id"
        type="checkbox"
        v-bind="$attrs"
        class="w-full h-full top-0 left-0 absolute opacity-0"
        :checked="modelValue"
        @input="$emit('update:modelValue', $event.target.checked)"
      >
      <div class="checkBall" />
    </div>
    <span>
      {{ label }}
    </span>
  </label>
</template>

<style scoped>
.checkBall {
  @apply w-6 h-6 rounded-full bg-red-600;
  transition: all 0.35s ease-in;
}

input:checked + .checkBall {
  @apply bg-blue-600 translate-x-8;
}
</style>
